diff --git a/projects/openttd_vs90.vcproj b/projects/openttd_vs90.vcproj
--- a/projects/openttd_vs90.vcproj
+++ b/projects/openttd_vs90.vcproj
@@ -52,7 +52,7 @@
 				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="2"
 				OmitFramePointers="true"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;WIN32_ENABLE_DIRECTMUSIC_SUPPORT;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;WITH_ASSERT"
 				StringPooling="true"
 				ExceptionHandling="1"
@@ -154,7 +154,7 @@
 				Name="VCCLCompilerTool"
 				AdditionalOptions="/MP"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;WIN32_ENABLE_DIRECTMUSIC_SUPPORT;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
@@ -254,7 +254,7 @@
 				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="2"
 				OmitFramePointers="true"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;_SQ64;WITH_ASSERT"
 				StringPooling="true"
 				ExceptionHandling="1"
@@ -358,7 +358,7 @@
 				Name="VCCLCompilerTool"
 				AdditionalOptions="/MP"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;_SQ64"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
@@ -468,6 +468,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\command_queue.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\console.cpp"
 				>
 			</File>
@@ -480,6 +484,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\copy_paste.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\currency.cpp"
 				>
 			</File>
@@ -496,6 +504,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\departures.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\depot.cpp"
 				>
 			</File>
@@ -564,18 +576,34 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini.cpp"
 				>
 			</File>
 			<File
-				RelativePath=".\..\src\ini_load.cpp"
-				>
-			</File>
-			<File
 				RelativePath=".\..\src\landscape.cpp"
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\linkgraph\demands.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\flowmapper.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\linkgraph.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\mcf.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\map.cpp"
 				>
 			</File>
@@ -588,6 +616,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\moving_average.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\music.cpp"
 				>
 			</File>
@@ -644,6 +676,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\programmable_signals.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\rail.cpp"
 				>
 			</File>
@@ -844,6 +880,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\command_queue.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\command_type.h"
 				>
 			</File>
@@ -888,6 +928,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\copy_paste.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\currency.h"
 				>
 			</File>
@@ -912,6 +956,18 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\departures_func.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\departures_gui.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\departures_type.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\depot_base.h"
 				>
 			</File>
@@ -1080,6 +1136,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure_func.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini_type.h"
 				>
 			</File>
@@ -1096,6 +1156,26 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\linkgraph\demands.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\flowmapper.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\linkgraph.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\linkgraph_type.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\linkgraph\mcf.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\livery.h"
 				>
 			</File>
@@ -1112,6 +1192,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\moving_average.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\network\network.h"
 				>
 			</File>
@@ -1336,6 +1420,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\programmable_signals.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\querystring_gui.h"
 				>
 			</File>
@@ -1591,6 +1679,18 @@
 				RelativePath=".\..\src\track_type.h"
 				>
 			</File>
+ 			<File
+				RelativePath=".\..\src\trafficlight.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\trafficlight_func.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\trafficlight_type.h"
+				>
+			</File>
 			<File
 				RelativePath=".\..\src\train.h"
 				>
@@ -1644,6 +1744,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\water.h"
 				>
 			</File>
@@ -1760,6 +1864,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\core\multimap.hpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\core\overflowsafe_type.hpp"
 				>
 			</File>
@@ -1840,6 +1948,14 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\copy_paste_gui.cpp"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\departures_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\depot_gui.cpp"
 				>
 			</File>
@@ -1928,6 +2044,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\programmable_signals_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\rail_gui.cpp"
 				>
 			</File>
@@ -2004,6 +2124,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\watch_gui.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\waypoint_gui.cpp"
 				>
 			</File>
@@ -2200,6 +2324,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\saveload\linkgraph_sl.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\saveload\map_sl.cpp"
 				>
 			</File>
@@ -2252,6 +2380,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\saveload\signal_sl.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\saveload\signs_sl.cpp"
 				>
 			</File>
@@ -2384,7 +2516,7 @@
 				>
 			</File>
 			<File
-				RelativePath=".\..\src\..\objs\settings\table\settings.h"
+				RelativePath=".\..\src\table\settings.h"
 				>
 			</File>
 			<File
@@ -3120,6 +3252,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\trafficlight.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ai\api\ai_vehicle.cpp"
 				>
 			</File>
diff --git a/projects/openttd_vs90.vcproj.in b/projects/openttd_vs90.vcproj.in
--- a/projects/openttd_vs90.vcproj.in
+++ b/projects/openttd_vs90.vcproj.in
@@ -52,7 +52,7 @@
 				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="2"
 				OmitFramePointers="true"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;WIN32_ENABLE_DIRECTMUSIC_SUPPORT;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;WITH_ASSERT"
 				StringPooling="true"
 				ExceptionHandling="1"
@@ -154,7 +154,7 @@
 				Name="VCCLCompilerTool"
 				AdditionalOptions="/MP"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;WIN32_ENABLE_DIRECTMUSIC_SUPPORT;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
@@ -254,7 +254,7 @@
 				EnableIntrinsicFunctions="true"
 				FavorSizeOrSpeed="2"
 				OmitFramePointers="true"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;_SQ64;WITH_ASSERT"
 				StringPooling="true"
 				ExceptionHandling="1"
@@ -358,7 +358,7 @@
 				Name="VCCLCompilerTool"
 				AdditionalOptions="/MP"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\objs\langs;..\objs\settings;..\src\3rdparty\squirrel\include"
+				AdditionalIncludeDirectories="..\objs\langs;..\src\3rdparty\squirrel\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;WITH_ZLIB;WITH_LZO;WITH_LZMA;LZMA_API_STATIC;WITH_PNG;WITH_FREETYPE;WITH_ICU;U_STATIC_IMPLEMENTATION;ENABLE_NETWORK;ENABLE_AI;WITH_PERSONAL_DIR;PERSONAL_DIR=\&quot;OpenTTD\&quot;;_SQ64"
 				BasicRuntimeChecks="3"
 				RuntimeLibrary="1"
diff --git a/projects/version_vs100.vcxproj b/projects/version_vs100.vcxproj
--- a/projects/version_vs100.vcxproj
+++ b/projects/version_vs100.vcxproj
@@ -30,7 +30,6 @@
     <NMakeBuildCommandLine Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">cscript "$(ProjectDir)/determineversion.vbs"</NMakeBuildCommandLine>
     <NMakeReBuildCommandLine Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">cscript "$(ProjectDir)/determineversion.vbs"</NMakeReBuildCommandLine>
     <NMakeOutput Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">..\src\rev.cpp</NMakeOutput>
-    <NMakeCleanCommandLine Condition="'$(Configuration)|$(Platform)'=='Debug|Win32'">del ..\src\rev.cpp</NMakeCleanCommandLine>
   </PropertyGroup>
   <ItemGroup>
     <None Include="..\src\os\windows\ottdres.rc.in" />
@@ -39,4 +38,4 @@
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.targets" />
   <ImportGroup Label="ExtensionTargets">
   </ImportGroup>
-</Project>
\ No newline at end of file
+</Project>
diff --git a/source.list b/source.list
--- a/source.list
+++ b/source.list
@@ -8,13 +8,16 @@
 cargotype.cpp
 cheat.cpp
 command.cpp
+command_queue.cpp
 console.cpp
 console_cmds.cpp
+copy_paste.cpp
 crashlog.cpp
 currency.cpp
 date.cpp
 debug.cpp
 dedicated.cpp
+departures.cpp
 depot.cpp
 driver.cpp
 economy.cpp
@@ -32,12 +35,17 @@
 heightmap.cpp
 highscore.cpp
 hotkeys.cpp
+infrastructure.cpp
 ini.cpp
-ini_load.cpp
 landscape.cpp
+linkgraph/demands.cpp
+linkgraph/flowmapper.cpp
+linkgraph/linkgraph.cpp
+linkgraph/mcf.cpp
 map.cpp
 misc.cpp
 mixer.cpp
+moving_average.cpp
 music.cpp
 network/network.cpp
 network/network_admin.cpp
@@ -91,6 +99,7 @@
 		#end
 	#end
 #end
+trafficlight.cpp
 vehicle.cpp
 vehiclelist.cpp
 viewport.cpp
@@ -127,6 +136,7 @@
 cmd_helper.h
 command_func.h
 command_type.h
+command_queue.h
 company_base.h
 company_func.h
 company_gui.h
@@ -136,6 +146,7 @@
 console_gui.h
 console_internal.h
 console_type.h
+copy_paste.h
 crashlog.h
 currency.h
 date_func.h
@@ -143,6 +154,9 @@
 date_type.h
 debug.h
 video/dedicated_v.h
+departures_func.h
+departures_gui.h
+departures_type.h
 depot_base.h
 depot_func.h
 depot_map.h
@@ -185,14 +199,21 @@
 industry.h
 industry_type.h
 industrytype.h
+infrastructure_func.h
 ini_type.h
 landscape.h
 landscape_type.h
 language.h
+linkgraph/demands.h
+linkgraph/flowmapper.h
+linkgraph/linkgraph.h
+linkgraph/linkgraph_type.h
+linkgraph/mcf.h
 livery.h
 map_func.h
 map_type.h
 mixer.h
+moving_average.h
 network/network.h
 network/network_admin.h
 network/network_base.h
@@ -314,6 +335,9 @@
 track_func.h
 track_type.h
 train.h
+trafficlight.h
+trafficlight_func.h
+trafficlight_type.h
 transparency.h
 transparency_gui.h
 transport_type.h
@@ -326,6 +350,7 @@
 vehiclelist.h
 viewport_func.h
 viewport_type.h
+watch_gui.h
 water.h
 waypoint_base.h
 waypoint_func.h
@@ -371,6 +396,7 @@
 core/math_func.cpp
 core/math_func.hpp
 core/mem_func.hpp
+core/multimap.hpp
 core/overflowsafe_type.hpp
 core/pool_func.cpp
 core/pool_func.hpp
@@ -391,7 +417,9 @@
 cheat_gui.cpp
 company_gui.cpp
 console_gui.cpp
+copy_paste_gui.cpp
 date_gui.cpp
+departures_gui.cpp
 depot_gui.cpp
 dock_gui.cpp
 engine_gui.cpp
@@ -414,6 +442,7 @@
 object_gui.cpp
 order_gui.cpp
 osk_gui.cpp
+programmable_signals_gui.cpp
 rail_gui.cpp
 road_gui.cpp
 roadveh_gui.cpp
@@ -433,6 +462,7 @@
 tree_gui.cpp
 vehicle_gui.cpp
 viewport_gui.cpp
+watch_gui.cpp
 waypoint_gui.cpp
 
 # Widgets
@@ -485,6 +515,7 @@
 saveload/group_sl.cpp
 saveload/industry_sl.cpp
 saveload/labelmaps_sl.cpp
+saveload/linkgraph_sl.cpp
 saveload/map_sl.cpp
 saveload/misc_sl.cpp
 saveload/newgrf_sl.cpp
@@ -498,6 +529,7 @@
 saveload/saveload.h
 saveload/saveload_filter.h
 saveload/saveload_internal.h
+saveload/signal_sl.cpp
 saveload/signs_sl.cpp
 saveload/station_sl.cpp
 saveload/storage_sl.cpp
@@ -532,7 +564,7 @@
 table/railtypes.h
 table/road_land.h
 table/roadveh_movement.h
-../objs/settings/table/settings.h
+table/settings.h
 table/sprites.h
 table/station_land.h
 table/strgen_tables.h
diff --git a/src/ai/api/ai_tile.hpp b/src/ai/api/ai_tile.hpp
--- a/src/ai/api/ai_tile.hpp
+++ b/src/ai/api/ai_tile.hpp
@@ -259,7 +259,7 @@
 	 * The returned height is the height of the bare tile. A possible foundation on the tile does not influence this height.
 	 * @param tile The tile to check on.
 	 * @pre AIMap::IsValidTile(tile).
-	 * @return The height of the lowest corner of the tile, ranging from 0 to 15.
+	 * @return The height of the lowest corner of the tile, ranging from 0 to 15, or 0 to 255 in case of AllowMoreHeightlevels().
 	 */
 	static int32 GetMinHeight(TileIndex tile);
 
@@ -268,7 +268,7 @@
 	 * The returned height is the height of the bare tile. A possible foundation on the tile does not influence this height.
 	 * @param tile The tile to check on.
 	 * @pre AIMap::IsValidTile(tile).
-	 * @return The height of the highest corner of the tile, ranging from 0 to 15.
+	 * @return The height of the highest corner of the tile, ranging from 0 to 15, or 0 to 255 in case of AllowMoreHeightlevels().
 	 */
 	static int32 GetMaxHeight(TileIndex tile);
 
@@ -278,7 +278,7 @@
 	 * @param tile The tile to check on.
 	 * @param corner The corner to query.
 	 * @pre AIMap::IsValidTile(tile).
-	 * @return The height of the lowest corner of the tile, ranging from 0 to 15.
+	 * @return The height of the lowest corner of the tile, ranging from 0 to 15, or 0 to 255 in case of AllowMoreHeightlevels().
 	 */
 	static int32 GetCornerHeight(TileIndex tile, Corner corner);
 
diff --git a/src/aircraft.h b/src/aircraft.h
--- a/src/aircraft.h
+++ b/src/aircraft.h
@@ -15,6 +15,19 @@
 #include "station_map.h"
 #include "vehicle_base.h"
 
+/**
+ * Minimal, maximal and holding flying altitude above ground while a plane is in flight
+ * and not starting or landing, i.e. in the state SLOWTURN & NOSPDCLAMP.
+ * Under certain circumstances, the actual flying altitude is
+ * higher, because certain offsets are added.
+ */
+enum AircraftFlyingAltitude {
+	AIRCRAFT_MIN_FLYING_ALTITUDE        = 120, ///< minimal flying altitude above tile.
+	AIRCRAFT_MAX_FLYING_ALTITUDE        = 360, ///< maximal flying altitude above tile.
+	PLANE_HOLD_MAX_FLYING_ALTITUDE      = 150, ///< holding flying altitude above tile of planes.
+	HELICOPTER_HOLD_MAX_FLYING_ALTITUDE = 184  ///< holding flying altitude above tile of helicopters. // check if disaster vehicles behave the same. ifnot make it so ...
+};
+
 struct Aircraft;
 
 /** An aircraft can be one of those types. */
@@ -25,7 +38,6 @@
 	AIR_ROTOR      = 6  ///< rotor of an helicopter
 };
 
-
 void HandleAircraftEnterHangar(Aircraft *v);
 void GetAircraftSpriteSize(EngineID engine, uint &width, uint &height, EngineImageType image_type);
 void UpdateAirplanesOnNewStation(const Station *st);
@@ -49,6 +61,22 @@
 	byte number_consecutive_turns; ///< Protection to prevent the aircraft of making a lot of turns in order to reach a specific point.
 	byte turn_counter;             ///< Ticks between each turn to prevent > 45 degree turns.
 
+	/**
+	 * True if an only if the aircraft has touched its upper altitude limit
+	 * and currently corrects its altitude. Used in order to avoid the
+	 * aircraft "stairclimbing". When an aircraft starts correcting
+	 * altitude it should make a rather big correction in one step.
+	 */
+	bool in_max_height_correction;
+
+	/**
+	 * True if an only if the aircraft has touched its lower altitude limit
+	 * and currently corrects its altitude. Used in order to avoid the
+	 * aircraft "stairclimbing". When an aircraft starts correcting
+	 * altitude it should make a rather big correction in one step.
+	 */
+	bool in_min_height_correction;
+
 	/** We don't want GCC to zero our struct! It already is zeroed and has an index! */
 	Aircraft() : SpecializedVehicleBase() {}
 	/** We want to 'destruct' the right class. */
